import Test.QuickCheck

odds :: [Int] -> [Int]
odds xs  =  [ x | x <- xs, odd x ]

oddsRec :: [Int] -> [Int]
oddsRec []                  =  []
oddsRec (x:xs) | odd x      =  x : oddsRec xs
               | otherwise  =  oddsRec xs
oddsCond :: [Int] -> [Int]
oddsCond ws  =
  if null ws then
    []
  else
    let
      x  = head ws
      xs = tail ws
    in
      if odd x then
        x : oddsCond xs
      else
        oddsCond xs

prop_odds :: [Int] -> Bool
prop_odds xs  =  odds xs == oddsRec xs
